﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TrackMyCatalogs_App.Controls
{
    [System.ComponentModel.DefaultBindingProperty("SelectedIndex")]
    /// <summary>
    /// Interaction logic for ListWithSearch.xaml
    /// </summary>    
    public partial class ListWithSearch : UserControl
    {
        private ICollectionView view;

        public static readonly DependencyProperty SelectedItemProperty =
            DependencyProperty.Register("SelectedItem", typeof(object), typeof(ListWithSearch));
        public static readonly DependencyProperty SelectedIndexProperty =
            DependencyProperty.Register("SelectedIndex", typeof(object), typeof(ListWithSearch));

        
        

       
        #region PROPERTIES

        public ICollectionView SearchFilter
        {
            get
            {
                return view;
            }
        }

        #region SEARCHTEXTBOX

        public string Text
        {
            get
            {
                return sBox.Text;
            }
            set
            {
                sBox.Text = value;
            }
        }

        public bool ShowSectionButton
        {
            get
            {
                return sBox.ShowSectionButton;
            }
            set
            {
                sBox.ShowSectionButton = value;
            }
        }

        #endregion

        #region LISTBOX

        public IEnumerable ListSource
        {
            get
            {
                return lst.ItemsSource;
            }
            set
            {
                lst.ItemsSource = value;
                view = CollectionViewSource.GetDefaultView(value);
            }
        }

        public DataTemplate ListItemTemplate
        {
            get
            {
                return lst.ItemTemplate;
            }
            set
            {
                lst.ItemTemplate = value;
            }
        }

        public object SelectedItem
        {
            get { return GetValue(SelectedItemProperty); }
            set { SetValue(SelectedItemProperty, value); }
        }

        public object SelectedIndex
        {
            get { return GetValue(SelectedIndexProperty); }
            set { SetValue(SelectedIndexProperty, value); }
        }
        #endregion
               

        #endregion

      

        public ListWithSearch()
        {
            InitializeComponent();

         
            SetEvents();


        }


        #region EVENTS

      

        private void SetEvents()
        {
            sBox.TextChanged += delegate
            {
                view.Refresh();
            };

            lst.SelectionChanged += delegate
            {
                SelectedItem = lst.SelectedItem;
                SelectedIndex = lst.SelectedIndex;
            };
        }
        

        #endregion

    }
}
